# -*- coding: utf-8 -*-
"""
Created on Tue Nov 16 17:26:54 2021

@author: coenv
"""

#import packages

import pyDOE2
import pandas as pd
import numpy as np
import math

#add variables
gamma = 100 #target shear rate #EDIT THIS VARIABLE WHEN USING OTHER INKS
n= 0.398 #Shear thinning index #EDIT THIS VARIABLE WHEN USING OTHER INKS
theta = 90.5 #EDIT THIS VARIABLE WHEN USING OTHER INKS

D =  [1.041, 0.859, 0.681, 0.609, 0.564, 0.437, 0.335, 0.234, 0.160, 0.110, 0.060] 

#Choose which head you are using
Head = 2                            #left to right, 1 through 5
Head_number = "H"+str(Head)
Target_head = "T1" + str(Head)

#Generate the design
    
dsgn=pyDOE2.ccdesign(3, center =(3,3), alpha='r', face='ccc')
pd.DataFrame(dsgn).to_csv(r"C:\Users\coenv\OneDrive - TU Eindhoven\Documents\6MSM00 - Graduation Project\Printing\GCODE\New DOE\Factor_settings.csv")



for nozzle in D:

    #Fit for pulses per microliter
    
    Pulses_per_uL = int(round(1383.5*(nozzle**-0.209),0)) #EDIT THIS VARIABLE WHEN USING OTHER INKS
    
    x,y,z = dsgn.T
    Speed=x
    Flow=y
    Standoff_dist=z
    
    #printing speed
    
    R_lvl0 = 0.5 #printing speed needed to achieve 100s-1 of shear halfway the nozzle (R* = 0.5)
    R_DoE_step = 0.15
    
    Speed_F = [round((30*n*gamma*nozzle)/((3*n+1)*(R_lvl0-element*R_DoE_step)),0) for element in Speed]
    
    #standoff distance
    
    C = ((1-math.cos(theta*math.pi/180))*math.sqrt(math.pi))/(math.sqrt( ((4)*theta*math.pi/180)) - (2*(math.sin(2*theta*math.pi/180))))
    
    d_DoE_step = 0.5
    d_lvl0 = (0.5/C)+(1.682*d_DoE_step)
    
    Standoff_dist_d = [round(((1-math.cos(theta*math.pi/180))*math.sqrt(math.pi))/(math.sqrt( ((4)*theta*math.pi/180)) - (2*(math.sin(2*theta*math.pi/180))))*nozzle*(d_lvl0+element*d_DoE_step),3) for element in Standoff_dist]
    
    #Flow
    
    S_lvl0 = 1
    S_DoE_step = 0.5
    
    Flow_S = [round(S_lvl0+element*S_DoE_step,3) for element in Flow]
    
    run_nrs = [i for i in range(1,21)]
    
    dsgn_num=np.array([run_nrs, Speed_F, Standoff_dist_d, Flow_S])
    dsgn_num=dsgn_num.T
    np.set_printoptions(suppress=True)
    pd.DataFrame(dsgn_num).to_csv(r"C:\Users\coenv\OneDrive - TU Eindhoven\Documents\6MSM00 - Graduation Project\Printing\GCODE\New DOE\numerical_design_"+str(nozzle) +".csv")
        
    np.random.shuffle(dsgn_num)
    
    new_column = [[i for i in range(1,21)]]
    
    rndm_dsgn_num=np.insert(dsgn_num, 0, new_column, axis=1)
    
    col1="std_order"
    col2="rndm_order"
    col3="Speed"
    col4="Standoff_distance"
    col5="Flow"
    
    row = np.array([col1,col2,col3,col4,col5])
    
    array=np.vstack([row,rndm_dsgn_num])
    
    pd.DataFrame(array).to_csv(r"C:\Users\coenv\OneDrive - TU Eindhoven\Documents\6MSM00 - Graduation Project\Printing\GCODE\New DOE\randomized_design_"+str(nozzle) +".csv", header=None, index=None)

    #Generate the GCODE file
    
    #Create an empty GCODE file
    
    f = open("OptimizingflowCV_GNP5_PU8_"+str(nozzle)+".GCODE", "a")
    
    # Home all axes
    
    print("G28 Z0", file=f)
    print("G28 X0 Y0", file=f)
    
    #Choose starting Z position
    Z_start = " Z100"
    
    print("M660 "+Head_number+Z_start+" ; Define starting Z position", file=f)
    
    #define starting X and Y
    
    X_start = "X100 "
    Y_start = "Y50"
    
    print("M6 "+Target_head+" O2 "+X_start+Y_start+" ; Define starting X and Y position", file=f)
    
    #Choose printing temperature
    #T_h = "[temperature_head]"
    #print("M109 T12 S"+T_h)
    
    #Choose tempeature for bed
    #T_b = "[temperature_bed]"
    #print("M190 S"+T_b)
    
    #Set priming parameters
    
    Prim_speed_n = "S10000" #speed at which prime move should be executed (usually 10000)
    Prim_pulses_n = "E30000" #number of pulses on the feed to execute
    Prim_dwelltime_n = "P5000" #number of milliseconds to dwell relative to start of the move
    
    print("M722 "+Prim_speed_n+" "+Prim_pulses_n+" "+Prim_dwelltime_n+" "+Target_head+" ; Set priming parameters", file=f)
    
    #Set unpriming parameters
    
    unPrim_speed_n = "S10000" #speed at which unprime move should be executed (usually 10000)
    unPrim_pulses_n = "E1000" #number of pulses on the feed to execute
    unPrim_dwelltime_n = "P-2000" #number of milliseconds to dwell relative to start of the move (usually negative number!)
    
    print("M721 "+unPrim_speed_n+" "+unPrim_pulses_n+" "+unPrim_dwelltime_n+" "+Target_head+" ; Set unpriming parameters", file=f)
    
    #correct for circular nozzle
    
    Flow_W = round(math.sqrt(math.pi/4)*nozzle,3)
    Flow_Z = round(math.sqrt(math.pi/4)*nozzle,3)
    
    #Set flow rate
    
    Flow_P_n = "P"+str(Pulses_per_uL) #Number of pulses on the motor to dispense 1 uL of material
    Flow_S_n = "S"+str(1) #Direct flow multiplier
    Flow_W_n = "W"+ str(Flow_W) #Width of the cross section of the volume to fill
    Flow_Z_n = "Z"+ str(Flow_Z) #Height of the cross section of the volume to fill
    
    print("M221 "+Flow_P_n+" "+Flow_S_n+" "+Target_head+" "+Flow_Z_n+" "+Flow_W_n+" ; Set flow parameters", file=f)
        
    #Set units to milimeters
    print("G21", file=f)
    
    #Set coordinates: relative
    print("G91", file=f)
     
    #Set coordinates: absolute
    print("G90", file=f)
    
    #Use absolute distances for extrusion
    print("M82", file=f)
    
    #Unknown
    print("G92 E0", file=f)
    
    #Invoke starting X and Y
    print("T"+str((Head-1)), file=f)
    
    #START PRINTING
    print(";-----Start printing-----", file=f)
    
    print("M221 "+Target_head+" "+Flow_P_n, file=f) #set new pulses per uL
    print("G0 X0 Y0", file=f) #goes to starting point XY
    print("G0 Z0 "+Head_number, file=f) #goes to starting point Z
    
    print("G1 X0 Y0 Z"+str(nozzle)+" E1", file=f) #Go to Z = Nozzle diameter
    print("G1 X0 Y60 E1", file=f) #Go to start position
    
    
    print("M221 "+Target_head+" S"+str(array[1,4]), file=f)
    print("G1 Z"+str(array[1,3])+" E1 F"+str(array[1,2]), file=f)
    print("G1 X3 Y60 E1", file=f)
    print("G1 X3 Y0 E1", file=f)
    
    print("M221 "+Target_head+" S"+str(array[2,4]), file=f)
    print("G1 Z"+str(array[2,3])+" E1 F"+str(array[2,2]), file=f)
    print("G1 X6 Y0 E1", file=f)
    print("G1 X6 Y60 E1", file=f)    
    
    print("M221 "+Target_head+" S"+str(array[3,4]), file=f)
    print("G1 Z"+str(array[3,3])+" E1 F"+str(array[3,2]), file=f)
    print("G1 X9 Y60 E1", file=f)
    print("G1 X9 Y0 E1", file=f)    
   
    print("M221 "+Target_head+" S"+str(array[4,4]), file=f)
    print("G1 Z"+str(array[4,3])+" E1 F"+str(array[4,2]), file=f)
    print("G1 X12 Y0 E1", file=f)
    print("G1 X12 Y60 E1", file=f)    

    print("M221 "+Target_head+" S"+str(array[5,4]), file=f)
    print("G1 Z"+str(array[5,3])+" E1 F"+str(array[5,2]), file=f)
    print("G1 X15 Y60 E1", file=f)
    print("G1 X15 Y0 E1", file=f)

    print("M221 "+Target_head+" S"+str(array[6,4]), file=f)
    print("G1 Z"+str(array[6,3])+" E1 F"+str(array[6,2]), file=f)
    print("G1 X18 Y0 E1", file=f)
    print("G1 X18 Y60 E1", file=f)

    print("M221 "+Target_head+" S"+str(array[7,4]), file=f)
    print("G1 Z"+str(array[7,3])+" E1 F"+str(array[7,2]), file=f)
    print("G1 X21 Y60 E1", file=f)
    print("G1 X21 Y0 E1", file=f)
    
    print("M221 "+Target_head+" S"+str(array[8,4]), file=f)
    print("G1 Z"+str(array[8,3])+" E1 F"+str(array[8,2]), file=f)
    print("G1 X24 Y0 E1", file=f)
    print("G1 X24 Y60 E1", file=f)   
    
    print("M221 "+Target_head+" S"+str(array[9,4]), file=f)
    print("G1 Z"+str(array[9,3])+" E1 F"+str(array[9,2]), file=f)
    print("G1 X27 Y60 E1", file=f)
    print("G1 X27 Y0 E1", file=f)    
    
    print("M221 "+Target_head+" S"+str(array[10,4]), file=f)
    print("G1 Z"+str(array[10,3])+" E1 F"+str(array[10,2]), file=f)
    print("G1 X30 Y0 E1", file=f)
    print("G1 X30 Y60 E1", file=f)
    
    print("M221 "+Target_head+" S"+str(array[11,4]), file=f)
    print("G1 Z"+str(array[11,3])+" E1 F"+str(array[11,2]), file=f)
    print("G1 X33 Y60 E1", file=f)
    print("G1 X33 Y0 E1", file=f)    
    
    print("M221 "+Target_head+" S"+str(array[12,4]), file=f)
    print("G1 Z"+str(array[12,3])+" E1 F"+str(array[12,2]), file=f)
    print("G1 X36 Y0 E1", file=f)
    print("G1 X36 Y60 E1", file=f)    
   
    print("M221 "+Target_head+" S"+str(array[13,4]), file=f)
    print("G1 Z"+str(array[13,3])+" E1 F"+str(array[13,2]), file=f)
    print("G1 X39 Y60 E1", file=f)
    print("G1 X39 Y0 E1", file=f)    

    print("M221 "+Target_head+" S"+str(array[14,4]), file=f)
    print("G1 Z"+str(array[14,3])+" E1 F"+str(array[14,2]), file=f)
    print("G1 X42 Y0 E1", file=f)
    print("G1 X42 Y60 E1", file=f)

    print("M221 "+Target_head+" S"+str(array[15,4]), file=f)
    print("G1 Z"+str(array[15,3])+" E1 F"+str(array[15,2]), file=f)
    print("G1 X45 Y60 E1", file=f)
    print("G1 X45 Y0 E1", file=f)

    print("M221 "+Target_head+" S"+str(array[16,4]), file=f)
    print("G1 Z"+str(array[16,3])+" E1 F"+str(array[16,2]), file=f)
    print("G1 X48 Y0 E1", file=f)
    print("G1 X48 Y60 E1", file=f)
    
    print("M221 "+Target_head+" S"+str(array[17,4]), file=f)
    print("G1 Z"+str(array[17,3])+" E1 F"+str(array[17,2]), file=f)
    print("G1 X51 Y60 E1", file=f)
    print("G1 X51 Y0 E1", file=f)   
    
    print("M221 "+Target_head+" S"+str(array[18,4]), file=f)
    print("G1 Z"+str(array[18,3])+" E1 F"+str(array[18,2]), file=f)
    print("G1 X54 Y0 E1", file=f)
    print("G1 X54 Y60 E1", file=f)        
    
    print("M221 "+Target_head+" S"+str(array[19,4]), file=f)
    print("G1 Z"+str(array[19,3])+" E1 F"+str(array[19,2]), file=f)
    print("G1 X57 Y60 E1", file=f)
    print("G1 X57 Y0 E1", file=f)   
    
    print("M221 "+Target_head+" S"+str(array[20,4]), file=f)
    print("G1 Z"+str(array[20,3])+" E1 F"+str(array[20,2]), file=f)
    print("G1 X60 Y0 E1", file=f)
    print("G1 X60 Y60 E1", file=f)     
    
    print("G1 X70 Y60 E1", file=f) #Go to end position   
    
    #Home Z-axis
    
    print("G28 Z0", file=f)
    
    #Clear offsets
    
    print("G53", file=f)
    
    #End print job
    
    print("M30", file=f)
    f.close()
    
