# -*- coding: utf-8 -*-
"""
Created on Tue Nov 16 17:26:54 2021

@author: coenv
"""

#import packages

import pyDOE2
import pandas as pd
import numpy as np
import math

#add variables
gamma = 100 #target shear rate
n= 0.112 #Shear thinning index
theta = 94.4 #Degrees
D =  [0.686, 0.564, 0.335] #Nozzle sizes available [mm]: 0.864, 0.686, 0.609, 0.564, 0.437, 0.335, 0.223, 0.160, 0.110, 0.060
ink_name = "CV-TEG-PU1"
#Generate the design
    
dsgn=pyDOE2.ccdesign(3, center =(3,3), alpha='r', face='ccc')
pd.DataFrame(dsgn).to_csv(r"C:\Users\coenv\OneDrive - TU Eindhoven\Documents\6MSM00 - Graduation Project\Printing\GCODE\3-factor DoE\Factor_settings.csv")

for nozzle in D:

    
    
    x,y,z = dsgn.T
    Speed=x
    Flow=y
    Standoff_dist=z
    
    #printing speed
    
    R_lvl0 = 0.5 #printing speed needed to achieve 100s-1 of shear halfway the nozzle (R* = 0.5)
    R_DoE_step = 0.5
    
    Speed_F = [round(((60*n*gamma*nozzle)/((3*n)+1))*(1+element*R_DoE_step),0) for element in Speed]
    #standoff distance
    
        
    C = ((1-math.cos(theta*math.pi/180))*math.sqrt(math.pi))/(math.sqrt( ((4)*theta*math.pi/180)) - (2*(math.sin(2*theta*math.pi/180))))
    print(C)
    d_DoE_step = 0.5
    d_lvl0 = (0.5/C)+(1.682*d_DoE_step)
    
    Standoff_dist_d = [round(((1-math.cos(theta*math.pi/180))*math.sqrt(math.pi))/(math.sqrt( ((4)*theta*math.pi/180)) - (2*(math.sin(2*theta*math.pi/180))))*nozzle*(d_lvl0+element*d_DoE_step),3) for element in Standoff_dist]
    
    #Flow
    
    S_lvl0 = 1
    S_DoE_step = 0.5
    
    Flow_S = [round(S_lvl0+element*S_DoE_step,3) for element in Flow]
    
    run_nrs = [i for i in range(1,21)]
    
    dsgn_num=np.array([run_nrs, Speed_F, Standoff_dist_d, Flow_S])
    dsgn_num=dsgn_num.T
    np.set_printoptions(suppress=True)
    pd.DataFrame(dsgn_num).to_csv(r"C:\Users\coenv\OneDrive - TU Eindhoven\Documents\6MSM00 - Graduation Project\Printing\GCODE\3-factor DoE\Factor_settings2.csv")
    
    
    
    np.random.shuffle(dsgn_num)
    
    new_column = [[i for i in range(1,21)]]
    
    rndm_dsgn_num=np.insert(dsgn_num, 0, new_column, axis=1)
    
    col1="std_order"
    col2="rndm_order"
    col3="Speed"
    col4="Standoff_distance"
    col5="Flow"
    
    row = np.array([col1,col2,col3,col4,col5])
    
    array=np.vstack([row,rndm_dsgn_num])
    
    pd.DataFrame(array).to_csv(r"C:\Users\coenv\OneDrive - TU Eindhoven\Documents\6MSM00 - Graduation Project\Printing\GCODE\3-factor DoE\Factor_settings_"+ink_name+" D"+str(nozzle) +".csv", header=None, index=None)
